<style>
    .col-xs-2, .col-xs-1{
        padding-left: 0;
    }
</style>

<?=Form::open(null, ['id' => 'widget-filter'])?>
<?= Form::hidden('_form', 'step1'); ?>
<div class="row-fluid">
    <!-- Net-->
    <div class="col-xs-1">
        <?=Form::input('net', Arr::get($post, 'net'), [
            'id' => 'net',
            'class'=>'form-control input-sm',
            'placeholder' => 'Net'
        ]);?>
    </div>

    <!-- Referrer -->
    <div class="col-xs-2">
        <?=Form::input('referrer', Arr::get($post, 'referrer'), [
            'id' => 'referrer',
            'class'=>'form-control input-sm',
            'placeholder' => 'Referrer'
        ]);?>
    </div>

    <!-- Link -->
    <div class="col-xs-2">
        <?=Form::input('link', Arr::get($post, 'link'), [
            'id' => 'link',
            'class'=>'form-control input-sm',
            'placeholder' => 'Link'
        ])?>
        <?=Form::checkbox('link_strong', '1', (bool)Arr::get($post, 'link_strong'), ['id' => 'link_strong'])?> Strong?
    </div>

    <!-- IP-->
    <div class="col-xs-2">
        <?=Form::input('ip', Arr::get($post, 'ip'), [
            'id' => 'ip',
            'class'=>'form-control input-sm',
            'placeholder' => '127.0.0.1'
        ]);?>
    </div>

    <!-- Version-->
    <div class="col-xs-1">
        <?=Form::input('version', Arr::get($post, 'version'), [
            'id' => 'version',
            'class'=>'form-control input-sm',
            'placeholder' => 'Version'
        ]);?>
    </div>

    <!-- Locations -->
    <div id="locations_js" class="col-xs-2">
        <div class="form-group">
            <div class="clearfix">
                <?= Form::select('locations[]', $locations, Arr::get($post, 'locations'), [
                    'class' => 'selectpicker',
                    'multiple' => '',
                    'style' => 'width: 100%; width: calc(100% - 30px);'
                ]); ?>
            </div>
        </div>
    </div>

    <!-- Data range -->
    <div class="col-xs-2 input-daterange input-group datepicker-range">
        <?=Form::input('date_start', Arr::get($post, 'date_start'), [
            'id' => 'date_start',
            'class' => 'form-control input-sm',
            'placeholder' => '1901/12/13'
        ]); ?>

        <span class="input-group-addon"> / </span>

        <?=Form::input('date_end', Arr::get($post, 'date_end'), [
            'id' => 'date_end',
            'class' => 'form-control input-sm',
            'placeholder' => '2038/01/19'
        ]); ?>
    </div>
</div>



<div class="row-fluid" style="margin-top: 40px; height: 30px;">
    <!-- Filter lists -->
    <div class="col-xs-2" style="width: 280px;">
        <div>
            <?= Form::select('user_query', $user_queries, Arr::get($post, 'user_query'), [
                'class' => 'selectpicker'
            ]); ?>
            <?= Form::button(null, '<span class="glyphicon glyphicon-floppy-save"></span>', [
                'class' => 'btn btn-primary input-sm',
                'style' => 'vertical-align: 3px;',
                'type' => 'button',
                'title' => 'Save to My queries',
                'data-toggle' => 'modal',
                'data-target' => '#modal-save-to-my-queries'
            ]); ?>
        </div>
    </div>

    <!-- Clients per page -->
    <div class="col-xs-2" style="width: 235px;">
        <div>
            <?= Form::select('cpp', $cpp, Arr::get($post, 'cpp', 20), [
                'class' => 'selectpicker'
            ]); ?>
        </div>
    </div>

    <div class="col-xs-2 pull-right">
        <?=Form::button('filter', 'Apply', [
            'id' => 'filter',
            'class'=>'btn btn-primary pull-right',
            'type'=>'submit'
        ]);?>
        <?=Form::button('reset', 'Reset', [
            'class'=>'btn btn-danger pull-right',
            'type'=>'submit',
            'style' => 'margin-right:10px'
        ]);?>
<!--        <div class="checkbox pull-right" style="margin-right: 10px;">-->
<!--            <label>-->
<!--                --><?//= Form::checkbox('online', '1', (bool)Arr::get($post, 'online')); ?>
<!--                --><?//=" Online?"?>
<!--            </label>-->
<!--        </div>-->
<!--	    <div class="checkbox pull-right" style="margin-right: 10px; margin-top: 10px;">-->
<!--		    <label>-->
<!--			    --><?//= Form::checkbox('exclude_clients', '1', (bool)Arr::get($post, 'exclude_clients')); ?>
<!--			    --><?//=" Excluding?"?>
<!--		    </label>-->
<!--	    </div>-->
    </div>
</div>

<div class="modal fade" id="modal-save-to-my-queries" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button style="margin-top: 2px;" type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <h4 class="modal-title" id="myModalLabel">Save current query to My queries</h4>
            </div>
            <div class="modal-body" style="max-height: 780px;">
                <div class="form-group">
                    <label>Name</label>
                    <?= Form::input('user_query_name', Arr::get($post, 'user_query_name'), ['class' => 'form-control']); ?>
                </div>
            </div>
            <div class="modal-footer">
                <?=Form::button('save_to_my_queries', 'Save', array('class' => 'btn btn-success')); ?>
            </div>
        </div>
    </div>
</div>
<?=Form::close()?>

<script>
	$(document).ready(function() {
		var $scopeWidget = $('#locations_js');
		var $selectLocations = $('select[name="locations[]"]', $scopeWidget);
		$selectLocations.select2({
			placeholder: "Country"
		}).data('select2').$container.addClass("input-sm").css('padding', 0);

        $('.selectpicker').selectpicker({
            style: 'btn-default btn-sm'
        });
	});
</script>
