<?php
$params = array_merge(
    require(__DIR__ . '/../../common/config/params.php'),
    require(__DIR__ . '/../../common/config/params-local.php'),
    require(__DIR__ . '/params.php'),
    require(__DIR__ . '/params-local.php')
);

return [
    'id' => 'app-backend',
    'name' => 'Backdoor',
    'basePath' => dirname(__DIR__),
    'controllerNamespace' => 'backend\controllers',
    'bootstrap' => ['log'],
    /*'on beforeRequest' => function ($event) {
        if(!Yii::$app->request->isSecureConnection){
            $url = Yii::$app->request->getAbsoluteUrl();
            $url = str_replace('http:', 'https:', $url);
            Yii::$app->getResponse()->redirect($url);
            Yii::$app->end();
        }
    },*/
    'modules' => [
       'gridview' =>  [
            'class' => '\kartik\grid\Module',
            // your other grid module settings
        ],
       'gridviewKrajee' =>  [
            'class' => '\kartik\grid\Module',
            // your other grid module settings
        ]
    ],
    'components' => [
        'request' => [
            'enableCookieValidation' => true,
            'cookieValidationKey' => '69PNggqfArD-9mR7H9lM3M0SaEBJD9Dr',
            'csrfParam' => '_csrf-backend',
        ],
        'assetManager' => [
            'bundles' => [
                'dmstr\web\AdminLteAsset' => [
                    'skin' => 'skin-black',
                ],
            ],
        ],
        'mail' => [
            'class' => 'yii\swiftmailer\Mailer',
            'useFileTransport' => false,//set this property to false to send mails to real email addresses
            //comment the following array to send mail using php's mail function
            'transport' => [
                'class' => 'Swift_SmtpTransport',
                'host' => 'smtp.gmail.com',
                'username' => '',
                'password' => '',
                'port' => '587',
                'encryption' => 'tls',
            ],
        ],
        
        'user' => [
            'identityClass' => 'backend\models\Admin',
            'enableAutoLogin' => true,
            'identityCookie' => ['name' => '_identity-backend', 'httpOnly' => true],
        ],
        'session' => [
            // this is the name of the session cookie used for login on the backend
            'name' => 'advanced-backend',
        ],
        'log' => [
            'traceLevel' =>0,
            
                'targets' => [
                [
                    'class' => 'yii\log\FileTarget',
                    'categories' => ['admininfo'],
                    'levels' => ['info'],
                    'exportInterval' => 1,
                    'logVars' => [],
                    'logFile' => '@app/runtime/logs/admininfo.log',
                ],
                
                
            
            ],
        ],
        'errorHandler' => [
            'errorAction' => 'site/error',
        ],
        'authManager' => [
            'class' => 'yii\rbac\PhpManager',
            'defaultRoles' => ['manager', 'admin', 'super_admin'],
            'itemFile' => '@backend/components/rbac/items.php',
            'assignmentFile' => '@backend/components/rbac/assignments.php',
            'ruleFile' => '@backend/components/rbac/rules.php'
        ],
        'urlManager' => [
            'enablePrettyUrl' => true,
            'showScriptName' => false,
            'rules' => [
                'login' => 'site/login',
                'bots' => 'bots/index',
                'honeypots' => 'honeypots/index',
                'testbots' => 'testbots/index',
                'commands' => 'commands/index',
                'groups' => 'groups/index',
                'files' => 'files/index',
                'upload/index' => 'upload',
                'sik' => 'sik/index',
                'tasks' => 'packedtasks/index',
                'downloads/<bot:[A-Za-z0-9_-]+>/<dir:[A-Za-z0-9_-]+>/<file:[^/]+>' => 'downloads/index',
                'downloadfile/<bot:[A-Za-z0-9_-]+>/<dir:[A-Za-z0-9_-]+>/<file:[^/]+>' => 'downloadfile/index',
                /*[
                    'class' => 'backend\components\BotUrlRule',
                ],*/

            ],
        ],
        
    ],
    
    'params' => $params,
];
